function codigo_principal

clear all
%close all

global quad
%todas as variaveis do quadrator, trajetoria etc
Inicializar_quad();

%abrir a janela de simulao, aonde normalizou a units posicao 
%significa porcentagem da tela, cor etc
%salvou numa variavel da struct QUAD
quad.Janela_principal = figure('units','normalized','position',[.05 .08 .90 .82],'name','Quadrotor Control Development Platform','color','w','numbertitle','off');

%outro field de QUAD: figura da simulacao 3D
quad.Figura_principal = axes('units','normalized','position',[.17 .08 .65 .8]);

%axes cria figuras(eixos cartesianos) 
%normalized:configuracoes para em vez de trabalhar com pixel(defaut) com % da tela
%Observe q ta criando uma variavel(campo de QUAD)q recebe a figura  [.87 .10 .115 .1]
%[posicao X ,posicaoY,TAM X E Y]
quad.Figura_x = axes('units','normalized','position',[.87 .89 .115 .1]);
quad.Figura_y = axes('units','normalized','position',[.87 .75 .115 .1]);
quad.Figura_z = axes('units','normalized','position',[.87 .61 .115 .1]);
quad.Figura_roll = axes('units','normalized','position',[.87 .47 .115 .1]);
quad.Figura_pitch = axes('units','normalized','position',[.87 .33 .115 .1]);
quad.Figura_yaw = axes('units','normalized','position',[.87 .19 .115 .1]);
quad.Figura_CSI = axes('units','normalized','position',[.87 .05 .115 .1]);

%definindo limite dos eixos para os 7graficos(1-3D e 6-2D)
%axis(variavel,[limites limites ...])
axis(quad.Figura_principal,[-5 5 -5 5 0 3])
axis(quad.Figura_x,[0 5 -5 5])
axis(quad.Figura_y,[0 5 -5 5])
axis(quad.Figura_z,[0 5 -5 5])
axis(quad.Figura_roll,[0 5 -90 90 ])
axis(quad.Figura_pitch,[0 5 -90 90 ])
axis(quad.Figura_yaw,[ 0 5 -180 180])

%Definindo nome dos eixos do grafico princial
% (x,y,z)label(variavel,'NOME')
xlabel(quad.Figura_principal,'X');
ylabel(quad.Figura_principal,'Y');
zlabel(quad.Figura_principal,'Z   ');
set(get(quad.Figura_principal,'zlabel'),'rotation',0)
%Definindo nome dos eixos dos 6 graficos laterais
xlabel(quad.Figura_x,'Time');
ylabel(quad.Figura_x,'X');

xlabel(quad.Figura_y,'Time');
ylabel(quad.Figura_y,'Y');

xlabel(quad.Figura_z,'Time');
ylabel(quad.Figura_z,'Z');

xlabel(quad.Figura_roll,'Time');
ylabel(quad.Figura_roll,'Roll');

xlabel(quad.Figura_pitch,'Time');
ylabel(quad.Figura_pitch,'Pitch');

xlabel(quad.Figura_yaw,'Time');
ylabel(quad.Figura_yaw,'Yaw');

%cria interface(caixa onde se insere os valores de X,Y,Z,yaw, tempo)
%'style', 'EDI' proporciona alteracao do texto(no caso  desejavel)
quad.handler.X = uicontrol('units','normalized','position',[.06 .85 .06 .04],'style','edit','fontsize',10,'string',2,'backgroundcolor','w');
quad.handler.Y = uicontrol('units','normalized','position',[.06 .75 .06 .04],'style','edit','fontsize',10,'string',0,'backgroundcolor','w');
quad.handler.Z = uicontrol('units','normalized','position',[.06 .65 .06 .04],'style','edit','fontsize',10,'string',0,'backgroundcolor','w');
quad.handler.YAW = uicontrol('units','normalized','position',[.06 .55 .06 .04],'style','edit','fontsize',10,'string',0,'backgroundcolor','w');
quad.handler.T = uicontrol('units','normalized','position',[.06 .45 .06 .04],'style','edit','fontsize',10,'string',0,'backgroundcolor','w');

%aqui ja usa style 'text' pois nao deseja alterar os textos da lateral
%X,Y,Z,YAW,Tempo
uicontrol('units','normalized','position',[.02 .85 .03 .04],'style','text','fontsize',10,'string','X','backgroundcolor','w');
uicontrol('units','normalized','position',[.02 .75 .03 .04],'style','text','fontsize',10,'string','Y','backgroundcolor','w');
uicontrol('units','normalized','position',[.02 .65 .03 .04],'style','text','fontsize',10,'string','Z','backgroundcolor','w');
uicontrol('units','normalized','position',[.02 .55 .03 .04],'style','text','fontsize',10,'string','Yaw','backgroundcolor','w');
uicontrol('units','normalized','position',[.01 .45 .04 .03],'style','text','fontsize',10,'string','Time','backgroundcolor','w');

%cria os botoes da interface e observe que eles chamam outras funcoes @...
%[posicao xy , tam xy](vetor 4 posicoes) determina a posicao e o tamanho as caixas de pushbutton
%'string' 'ushdua': string que aparece no pushbutton

uicontrol('units','normalized','position',[.025 .95 .1 .03],'style','pushbutton','fontsize',10,'string','Save Simulation','callback',@SalvarSimulacao);

uicontrol('units','normalized','position',[.025 .9 .1 .03],'style','pushbutton','fontsize',10,'string','Set Waypoint','callback',@MarcarWaypoint);

quad.BotaoPSO = uicontrol('units','normalized','position',[.025 .36 .1 .03],'style','pushbutton','fontsize',10,'string','PSO Tunning','callback',@PSOTunning);

uicontrol('units','normalized','position',[.025 .31 .1 .03],'style','pushbutton','fontsize',10,'string','Set Parameters','callback',@Configurar_Parametros);

quad.BotaoCalcTraj = uicontrol('units','normalized','position',[.025 .21 .1 .03],'style','pushbutton','fontsize',10,'string','Start Simulation','callback',@CalcularTrajetoria);

uicontrol('units','normalized','position',[.025 .16 .1 .03],'style','pushbutton','fontsize',10,'string','End/Clean Simulation','callback',@Limpar_Simulacao);
%popup(menu) cria opcoes a serem marcadas
quad.ListaControlador = uicontrol('units','normalized','position',[0.025 .05 .1 .03],'style','popupmenu','fontsize',10,'string',{'Linear Control';'Nonlinear Control';'Geometric Tracking'},'value',1);

PlotQuad();

drawnow
%enquanto PodeComecar =0: LoopPrincipal roda
%LoopPrincipal: funcao logo abaixo
while(~quad.PodeComecar)
    Loop_Principal();
end

end



function Loop_Principal()
global quad;

Inicializar_quad();
while(~quad.PodeComecar) % Podecomecar=0
    %para marcar os pontos desejados com X antes mesmo de seguir trajetoria
    drawnow %vai atualizando a figura 
    PlotQuad();
end
%ao apertar Calcular trajetoria: Podecomecar = 1
while(quad.PodeComecar == 1)
   tic %starts measuring time
   
 %meio inutil, queria simular erros dos sensores etc
   Medicoes();
   
   %determina qual controlador utilizar a partir do popupmenu acima
   try
   if(get(quad.ListaControlador,'Value')==1)
       Controlador();
   elseif(get(quad.ListaControlador,'Value')==2)
       ControladorNaoLinear();
   elseif(get(quad.ListaControlador,'Value')==3)
       ControladorNaoLinearArtigo();
   end
   catch %caso nao seja nenhum deles para o programa ?
       return
   end
   %chama a funcao Modelo
   Modelo();
   %
   try
%     if(quad.iteracao < 5 && quad.iteracao > 1)
%         disp('a')
%         disp(quad.x_plot)
%         disp(quad.y_plot)
%         disp(quad.z_plot)
%     end
        %plota o grafico APENAS de 10 em 10 iteracoes para evitar lentidao
       if(~mod(quad.iteracao,10))
            PlotQuad();
       end
   catch
       return
   end
   drawnow
   %toc  o tempo passado a partir do TIC acima
   %delay toc-  dt(tempo de amostragem)
   %segurar o programa pra nao andar mais rapido que o tempo de amostragem
   while(toc<quad.dt)
   end
   
  quad.iteracao=quad.iteracao+1;
end
%clicar em LIMPAR SIMULACAO
if(quad.PodeComecar == 3)
     limits=[8500*ones(length(quad.rds(1,:)),1) 1300*ones(length(quad.rds(1,:)),1)];
     figure(2)
     subplot(1,4,1)
     hold off
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),quad.Wnovo(1:length(quad.rds(1,:)),1)*60/(2*pi),'b'); %rotacoes em rpm do motor 1
     hold on
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,1),'r--');
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,2),'r--');
     max1 = max(abs(quad.Wnovo(1:length(quad.rds(1,:)),1))*60/(2*pi));
     axis([0 quad.dt*length(quad.rds(1,:)) 0 9000]); grid
     title('N_1')
     xlabel('Time [s]')
     ylabel('Speed [rpm]')
     subplot(1,4,2)
     hold off
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),quad.Wnovo(1:length(quad.rds(1,:)),2)*60/(2*pi),'b'); %rotacoes em rpm do motor 2figure;
     hold on
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,1),'r--');
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,2),'r--');
     max2 = max(abs(quad.Wnovo(1:length(quad.rds(1,:)),2))*60/(2*pi));
     axis([0 quad.dt*length(quad.rds(1,:)) 0 9000]); grid
     title('N_2')
     xlabel('Time [s]')
     ylabel('Speed [rpm]')
     subplot(1,4,3);
     hold off
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),quad.Wnovo(1:length(quad.rds(1,:)),3)*60/(2*pi),'b'); %rotacoes em rpm do motor 3figure;
     hold on
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,1),'r--');
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,2),'r--');
     max3 = max(abs(quad.Wnovo(1:length(quad.rds(1,:)),3))*60/(2*pi));
     axis([0 quad.dt*length(quad.rds(1,:)) 0 9000]); grid
     title('N_3')
     xlabel('Time [s]')
     ylabel('Speed [rpm]')
     subplot(1,4,4);
     hold off
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),quad.Wnovo(1:length(quad.rds(1,:)),4)*60/(2*pi),'b'); %rotacoes em rpm do motor 4figure;
     hold on
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,1),'r--');
     plot(0.02:0.02:quad.dt*(length(quad.rds(1,:)-1)),limits(:,2),'r--');
     max4 = max(abs(quad.Wnovo(1:length(quad.rds(1,:)),4))*60/(2*pi));
     axis([0 quad.dt*length(quad.rds(1,:)) 0 9000]); grid
     title('N_4')
     xlabel('Time [s]')
     ylabel('Speed [rpm]')
     set (gcf,'Color','white')
     set (gcf,'Position',[10 200 1500 200])
     
% %      figure(6);
% %      plot(quad.Forcas(:,1));
% %      figure(7);
% %      plot(quad.Forcas(:,2));
% %      figure(8);
% %      plot(quad.Forcas(:,3));
% %      figure(9);
% %      plot(quad.Forcas(:,4));
% %      figure(10)
%      plot(quad.Forcasnovas(:,1));
%      figure(11);
%      plot(quad.Forcasnovas(:,2));
%      figure(12);
%      plot(quad.Forcasnovas(:,3));
%      figure(13);
%      plot(quad.Forcasnovas(:,4));
%     figure (14);
%     plot(quad.salva_1);
%     figure (15);
%     plot(quad.salva_2);
    RMS_da_trajetoria(); 
%     plot(quad.Figura_CSI,quad.CSI,'b')
%     axis (quad.Figura_CSI,[0 length(quad.CSI) 0 2.5])
%     xlabel(quad.Figura_CSI,'Tempo');
%     ylabel(quad.Figura_CSI,'CSI');
%     hold(quad.Figura_CSI,'on');
    
%     figure(16)
%     plot(quad.CSI);
%     axis([0 length(quad.CSI) 0 2])
 
    quad.PodeComecar = 0;
end
end
